(*
	Test/Beispiel-Applikation fr die GEMScript Unit

	Written 1998 by Volker Janzen

	Diese Datei darf als Grundgerst fr eigene Programme
	verwendet werden
*)
{$X+}		(* Funktionen drfen als Proceduren aufgerufen werden *)
{$E .APP}	(* Extension der compilierten Datei: APP *)

Uses GEM, GScript, Strings; (* Bentigte Units einbinden *)

{$I GSCRIPT.I } (* Datei mit Konstantendefinitionen einbinden *)

VAR
	(*
		Zeigt an ob das Programm den Befehl "Quit" per GEMScript
		erhalten hat (fr die Abbruchbedingung)
	*)
	gs_got_quit	: BOOLEAN;
	(*
		Array fr evnt_mesag
	*)
	pipe		: ARRAY_8;

(*
	Handlerfunktion GSHandler - wird von der GEMScript-Unit aufgerufen,
	die Application soll einen GEMScriptbefehl bearbeiten

	command:	Enthlt das empfangene Kommando in KLEINSCHREIBUNG
	retstr:		PChar in den der Returnstring kopiert werden soll
				(am Besten mit StrPCopy(retstr, PascalString+#0),
				damit sollte sichergestellt sein, das der Returnstring
				mit Doppelnullbyte abgeschlossen ist)
*)
FUNCTION GSHandler(command : String; retstr: PChar): Integer;
VAR
	ret: Integer;
BEGIN

	(* Defaultrckgabe: wir kennen den GEMScriptbefehl nicht *)
	ret:=GSACK_UNKNOWN;

	IF command='quit' THEN (* Kommando Quit *)
	BEGIN
		gs_got_quit:=true;		(* Flag setzen: Programm verlassen *)
		StrPCopy(retstr, '0'+#0);	(* Returnstring kopieren *)
		ret:=GSACK_OK;			(* Rckmeldung: Befehl verstanden *)
	END;

	GSHandler:=ret;
END;

VAR
	ap_id: Integer;
BEGIN
	gs_got_quit:=false;	(* Variable initialisieren *)

	ap_id:=appl_init;	(* Beim GEM anmelden *)

	GEMScriptInit(ap_id, 'Testprogramm', 512, GSHandler);	(* Unit initialisieren *)

	repeat
		evnt_mesag(pipe);		(* Auf Messageereignis warten *)
		Handle_GMessage(@pipe);	(* und an die Unit zur Auswertung bergeben *)
		(* Auf Shutdown reagieren *)
		IF pipe[0]=50 THEN gs_got_quit:=True;
	until (gs_got_quit=true);	(* Warten auf Abbruchbedingung *)

	GEMScriptExit;	(* Unit deinitialisieren *)

	appl_exit;	(* Beim GEM abmelden *)
END.
